#
# umpk04.rb
#
# $Id: umpk04.rb,v 1.1 2000/11/22 14:36:01 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


NX = 19
NY = 19
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = +90
DRAD = PI/180
DZ = 0.05
DP = 0.2
p = NArray.new(Float, NX, NY)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1)) * DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1)) * DRAD
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + DZ
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

rmiss = glrget('RMISS')
sglset('LSOFTF', false)

grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.1, 0.9, 0.1, 0.9)
grssim(0.4, 0.0, 0.0)
grsmpl(165.0, 60.0, 0.0)
grstxy(-180.0, 180.0, 0.0, 90.0)
grstrn(30)
grstrf
sglset('LCLIP', true)

uestlv(rmiss, -DP, 201)
uestlv(DP, DP*2, 401)
uestlv(DP*2, rmiss, 402)
uetone(p, NX, NX, NY)

udgclb(p, NX, NX, NY, DP)
udcntr(p, NX, NX, NY)

umpmap('coast_world')
umpglb

grcls

